﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;


namespace sph
{
    class Water 
    {
        private float _v;
        public float v
        { get { return _v; } }

        private float _density;
        public float Density
        { get { return _density; } }

        private float _restdensity;
        public float Restdensity
        { get { return _density; } }

        private Vector3 _position;
        public Vector3 Position
        { get { return _position; } }

        private float _mass;
        public float Mass
        { get { return _mass; } }

        private float _gravity;
        public float Gravity
        { get { return _gravity; } }

        private float _h;
        public float h
        { get { return _h; } }

        private float _gas_constant_k;
        public float Gas_Constant_k
        { get { return _gas_constant_k; } }

        private float _presure;
        public float Presure
        { get { return _presure; } }

        private float _pressure_force;
        public float Pressure_Force
        { get { return _pressure_force; } }

        private float _viscosity_force;
        public float Viscosity_Force
        { get { return _viscosity_force; } }

        private float _color_field_gradient;
        public float Color_Field_Gradient
        { get { return _color_field_gradient; } }

        private float _color_field_laplacian;
        public float Color_Field_Laplacian
        { get { return _color_field_laplacian; } }

        private float _velocity;
        public float Velocity
        { get { return _velocity; } }


        public Water(Game game, Vector3 position_, float mass_, float gravity_, float v_, float h_)
        {
            _h = h_;
            _position = position_;
            _v = v_;
            _mass = mass_;
            _gravity = gravity_;

        }

        #region functions

        private float W_poly6(float r_r, float h_h,float mass)
        {
            float add_to_density;
            add_to_density = mass*(((315 / 64 * MathHelper.Pi * h * h * h * h * h * h * h * h * h)) * ((h_h * h_h) - (r_r * r_r) * (r_r * r_r) * (r_r * r_r)));
                
            return add_to_density; 
        }
        private float _pressure_calc()
        {
            _presure = _gas_constant_k * (_density - _restdensity);
            return _presure;
        }        
        private float gradient_W_spikey(float r)
        {
            float W_visc = r * (15 / (2 * MathHelper.Pi * h * h * h) * (-(3 * r) / (2 * h * h * h) + (2 / (h * h)) - (h / (2 * r * r * r))));
            return W_visc;
        }
        private float laplacian_W_viscosity(float r)
        {
            float W_lap_visc = 45 / MathHelper.Pi * h * h * h * h * h * (1 - (r / h));
            return W_lap_visc;
        }
        private float W_poly6_grad(float r)
        {
            float grad = -r * 945 / 32 * MathHelper.Pi * h * h * h * h * h * h * h * h * h * ((h * h - r * r) * (h * h - r * r));
            return grad;
        }
        private float W_poly6_lap(float r)
        {
            float lap = 945 / 8 * MathHelper.Pi * h * h * h * h * h * h * h * h * h * (h * h - r * r) * (r * r - ((3 / 4) * (h * h - r * r)));
            return lap;
        }
       

        #endregion

        public void Update_Water(List<Water> Neighbors)
        {
            for (int i = 0; i < Neighbors.Count; i++)
            {
                float distace = Vector3.Distance(Position,Neighbors.ElementAt<Water>(i).Position);
                if (distace < h)
                {
                    _density+= W_poly6(Math.Abs(distace), h,Neighbors.ElementAt<Water>(i).Mass);
                }              

            }
            for (int i = 0; i < Neighbors.Count; i++)
            {
                float r = Vector3.Distance(Position,Neighbors.ElementAt<Water>(i).Position);
                if (r < h)
                {
                    float pressure_now = _pressure_calc();
                    float pressure_neighbour = Neighbors.ElementAt<Water>(i)._pressure_calc();

                    _pressure_force += _mass * (pressure_now + pressure_neighbour) / (2 * Neighbors.ElementAt<Water>(i).Density) * gradient_W_spikey(r);
                    _velocity += _mass * (Neighbors.ElementAt<Water>(i).Velocity - _velocity) / Neighbors.ElementAt<Water>(i).Density * laplacian_W_viscosity(r);
                    _color_field_gradient += _mass / Neighbors.ElementAt<Water>(i).Density * W_poly6_grad(r);
                    _color_field_laplacian += _mass / Neighbors.ElementAt<Water>(i).Density * W_poly6_lap(r);
                }

            }
            for (int i = 0; i < Neighbors.Count; i++)
            {
                float grad_length = _color_field_gradient;
                
            }
                
            
            
        }
    
 
            
    }
}
